%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2015.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|

%=======================================================================|
%Function description
%Function evaluates AUC
%Input variables:
%data1 = benchmark
%data2 = probabilities
%Output variables:
%AUC = value of AUC

function [AUC] = AUCdata(data1, data2)

lengthloc=size(data2);
report=[];
        dotROC=[];   
        threshold=0;
        for i=1:101,
            threshold=0.01*i-0.01;        
            TP=0;FP=0;TN=0;FN=0;
            for ii=1:lengthloc(1),
                if data2(ii)<=threshold, 
                    if data1(ii)==0,  TN=TN+1;
                    else FN=FN+1;
                    end
                end;
                if data2(ii)>= threshold,  
                    if data1(ii)==1,  TP=TP+1;
                    else FP=FP+1;
                    end
                end

            end;
            TPR=TP/(TP+FN);
            FPR=FP/(FP+TN);           
            dotROC=cat(1,dotROC,[TPR,FPR]);

        end;

            datax=sort(dotROC(1:end,2));
            datay=sort(dotROC(1:end,1));
            AUC1=(datax(2:end)-datax(1:(end-1)));
            AUC2=(datay(2:end)+datay(1:(end-1)));
            AUC=sum(AUC1.*AUC2)/2;        
        
        
end